﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'**********************************
'*** Horizontal ICSLike Seekbar ***
'***  version 1.12 - by mabool + Peacemaker  ***
'**********************************
Sub Class_Globals
	Private mbBackground As Panel 
	Private mbBtn, mbBtn2 As Panel
	Private mbActivity As Activity
	Private mbEventName As String
	Private mbModule As Object
	Private mbLabel, mbLabel2 As Label

	Private textVisible As Boolean
	Private bgPaint As ABPaint
	Private mbLine As ABExtDrawing
	Private cvs_disabled As Canvas
	Private cvs_normal As Canvas
	Private cvs_pressed As Canvas
	Private lineColor As Int
	Private btnColor As Int
	Private radius As Double
	Private cvsmbBackground As Canvas
	Private areaRect As Rect

	Public  maxValue As Int
	Public  minValue As Int
	Public stepValue As Int = 500 'default is 1
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(myActivity As Activity,Module As Object,EventName As String,myLeft As Int,myTop As Int,myWidth As Int,myHeight As Int,myStrokewidth As Double,myStrokecolor As Int,myBtncolor As Int,myTextvisible As Boolean,initValue As Int, initValue2 As Int, myMin As Int, myMax As Int) As Object

	mbActivity = myActivity
	mbEventName = EventName
	mbModule = Module
	textVisible = myTextvisible
	minValue = myMin
	maxValue = myMax
	
	lineColor = myStrokecolor
	btnColor = myBtncolor
	radius = myHeight/2
	
'   *** background ***	
	mbBackground.Initialize("mbBackground")
	mbBackground.color = Colors.Transparent
	mbBackground.Tag ="mbhs"
	mbActivity.AddView(mbBackground,myLeft,myTop,myWidth,myHeight)
	areaRect.Initialize(0,0,mbBackground.Width, mbBackground.Height)
	cvsmbBackground.Initialize(mbBackground)

	bgPaint.Initialize
	bgPaint.SetAntiAlias(True)
	bgPaint.SetStyle(bgPaint.Style_STROKE)
	bgPaint.SetStrokeWidth(myStrokewidth)
	'bgPaint.SetAlpha(145)
	bgPaint.SetColor(lineColor)
	mbLine.drawLine(cvsmbBackground,radius, radius, mbBackground.Width-radius, radius, bgPaint)
'   *** end background ***	

'   *** button ***	
	mbBtn.Initialize("mbBtn")
	mbBtn.color = Colors.Transparent
	mbBackground.AddView(mbBtn, 0,0, myHeight, myHeight)

	mbBtn2.Initialize("mbBtn2")
	mbBtn2.color = Colors.Transparent
	mbBackground.AddView(mbBtn2, 100,0, myHeight, myHeight)

'   *** painting canvas ***	
	Dim btnDrawing As ABExtDrawing
	Dim btnPaint As ABPaint
	btnPaint.Initialize
	btnPaint.SetAntiAlias(True)

	Dim btnCenter As ABPaint
	btnCenter.Initialize
	btnCenter.SetStyle(btnCenter.Style_FILL)
	btnCenter.SetColor(Colors.White)
	
'	*** create bitmap disabled ***	
	Dim bmp_disabled As Bitmap
	bmp_disabled.InitializeMutable(myHeight,myHeight)
	cvs_disabled.Initialize2(bmp_disabled)
	btnPaint.SetStyle(btnPaint.Style_FILL)
	btnPaint.SetColor(Colors.RGB(136,136,136))

	btnDrawing.drawCircle(cvs_disabled,radius,radius,radius ,btnPaint)
	btnDrawing.drawCircle(cvs_disabled,radius,radius,radius/1.5, btnCenter)
	btnPaint.SetColor(lineColor)	'(myBtncolor)

	'btnDrawing.drawCircle(cvs_disabled,radius,radius,myHeight/9 ,btnPaint)


'	*** create bitmap pressed ***	
	Dim bmp_pressed As Bitmap
	bmp_pressed.InitializeMutable(myHeight,myHeight)
	cvs_pressed.Initialize2(bmp_pressed)
	btnPaint.SetStyle(btnPaint.Style_FILL)
	btnPaint.SetColor(lineColor)	'(myBtncolor)
	'btnPaint.SetAlpha(154)
	btnDrawing.drawCircle(cvs_pressed,radius,radius,radius ,btnPaint)
	btnDrawing.drawCircle(cvs_pressed,radius,radius,radius/1.5, btnCenter)
	btnPaint.SetStyle(btnPaint.Style_STROKE)
	btnPaint.SetStrokeWidth(2dip)
	btnDrawing.drawCircle(cvs_pressed,radius,radius,radius-2dip ,btnPaint)
	btnDrawing.drawCircle(cvs_pressed,radius,radius,radius/1.5, btnCenter)
	If myTextvisible = False Then
		'btnPaint.SetAlpha(255)
	btnPaint.SetStyle(btnPaint.Style_FILL)
	'btnDrawing.drawCircle(cvs_pressed,radius,radius,myHeight/6 ,btnPaint)
	End If
'	*** create bitmap normal ***	
	cvs_normal.Initialize(mbBtn)
	btnPaint.SetStyle(btnPaint.Style_FILL)
	btnPaint.SetColor(lineColor)	'(myBtncolor)
	btnDrawing.drawCircle(cvs_normal,radius,radius,radius ,btnPaint)
	btnDrawing.drawCircle(cvs_normal,radius,radius,radius/1.5, btnCenter)
	
	cvs_normal.Initialize(mbBtn2)
	btnPaint.SetStyle(btnPaint.Style_FILL)
	btnPaint.SetColor(lineColor)	'(myBtncolor)
	btnDrawing.drawCircle(cvs_normal,radius,radius,radius ,btnPaint)
	btnDrawing.drawCircle(cvs_normal,radius,radius,radius/1.5, btnCenter)
	
	
'	*** draw center only if no text
	If myTextvisible = False Then
		'btnPaint.SetAlpha(255)
		'btnDrawing.drawCircle(cvs_normal,radius,radius,myHeight/6 ,btnPaint)
	End If
'   *** end painting canvas ***	

	mbActivity.Invalidate
	
	If textVisible = True Then
		mbLabel.Initialize("")
		mbBtn.AddView(mbLabel,0,0,mbBtn.Width,mbBtn.Height)	
		mbBtn2.AddView(mbLabel,0,0,mbBtn.Width,mbBtn.Height)
		mbLabel.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
		CustomizeText(Colors.White,14,Typeface.DEFAULT)
		mbLabel.Text = returnValue

		mbLabel2.Initialize("")
		mbBtn.AddView(mbLabel2,0,0,mbBtn2.Width,mbBtn2.Height)
		mbBtn2.AddView(mbLabel2,0,0,mbBtn2.Width,mbBtn2.Height)
		mbLabel2.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
		CustomizeText(Colors.White,14,Typeface.DEFAULT)
		mbLabel2.Text = returnValue2

	End If

	setValue (initValue)
	setValue2 (initValue2)

End Sub

Private Sub mbBackground_Touch (Action As Int, X As Float, Y As Float)
	Dim LeftBtn As Boolean
		If x <= mbBtn.Left + mbBtn.Width Then
			LeftBtn = True
			mbBtn.Left = X - radius
		Else if x >= mbBtn2.Left Then
			LeftBtn = False
			mbBtn2.Left = X - radius
		End If

	If LeftBtn Then

		Select Action
			Case mbActivity.ACTION_DOWN
				mbBtn.SetBackgroundImage(cvs_pressed.Bitmap)
				mbBtn.BringToFront
			Case mbActivity.ACTION_UP
				mbBtn.SetBackgroundImage(cvs_normal.Bitmap)
				setValue(Round(returnValue/stepValue) * stepValue)

		End Select
		' *** check limits ***
				If mbBtn.Left < 0 Then
					mbBtn.Left = 0
				End If
		If (mbBtn.Left ) > mbBtn2.Left Then
			mbBtn.Left = mbBtn2.Left
		End If


	Else
		Select Action
			Case mbActivity.ACTION_DOWN
				mbBtn2.SetBackgroundImage(cvs_pressed.Bitmap)
				mbBtn2.BringToFront
			Case mbActivity.ACTION_UP
				mbBtn2.SetBackgroundImage(cvs_normal.Bitmap)
				setValue2(Round(returnValue2/stepValue) * stepValue)

		End Select
		' *** check limits ***
		If mbBtn2.Left < mbBtn.Left Then
			mbBtn2.Left = mbBtn.Left
		End If
		If (mbBtn2.Left + mbBtn2.Width) > mbBackground.Width Then
			mbBtn2.Left =  mbBackground.Width - mbBtn2.Width
		End If

	End If
	' *** clear lines in background ***
	Redraw_Background(True)

	If textVisible = True Then
		mbLabel.text = returnValue
		mbLabel2.text = returnValue2
	End If
	If SubExists(mbModule, mbEventName) Then
		CallSub3(mbModule, mbEventName, returnValue, returnValue2)
	End If
End Sub



Private Sub Redraw_Background(Enabled As Boolean)
	cvsmbBackground.drawRect(areaRect, Colors.Transparent, True, 0)
	mbBackground.Invalidate
	bgPaint.SetColor(lineColor)
	'bgPaint.SetAlpha(145)
	mbLine.drawLine(cvsmbBackground, radius, radius, mbBackground.Width - radius, radius, bgPaint)
	If Enabled = True Then
		bgPaint.SetColor(btnColor)
		'bgPaint.SetAlpha(255)
			If (textVisible = True) Then
				If mbBtn.Left > radius Then
					mbLine.drawLine(cvsmbBackground, radius, radius, mbBtn.Left, radius, bgPaint)
				End If
			Else
				mbLine.drawLine(cvsmbBackground, radius, radius, mbBtn.Left + radius, radius, bgPaint)
			End If
	End If

	bgPaint.SetColor(btnColor)	'lineColor
	'bgPaint.SetAlpha(145)
	'mbLine.drawLine(cvsmbBackground, radius, radius, mbBackground.Width - radius, radius, bgPaint)
	If Enabled = True Then
		bgPaint.SetColor(lineColor)	'btnColor
		'bgPaint.SetAlpha(255)
			If (textVisible = True) Then
				If mbBtn2.Left > radius Then
					mbLine.drawLine(cvsmbBackground, radius, radius, mbBtn2.Left, radius, bgPaint)
				End If
			Else
				mbLine.drawLine(cvsmbBackground, radius, radius, mbBtn2.Left + radius, radius, bgPaint)
			End If
	End If
End Sub


Public Sub CustomizeText(fontColor As Int,FontSize As Int,myTypeface As Typeface)
	If textVisible = True Then
		mbLabel.Typeface = myTypeface
		mbLabel.TextColor = fontColor
		mbLabel.TextSize = FontSize
	End If	
	End Sub
Public Sub returnValue
	Return  Round(mbBtn.Left /((mbBackground.Width-mbBtn.Width) / (maxValue- minValue))) + minValue
End Sub
Public Sub returnValue2
	Return  Round(mbBtn2.Left /((mbBackground.Width-mbBtn2.Width) / (maxValue- minValue))) + minValue
End Sub

Public Sub setValue(Value As Int)
	mbBtn.Left = Round ((Value - minValue) * ((mbBackground.Width-mbBtn.Width) / (maxValue- minValue)))
	Redraw_Background(True)
	If textVisible = True Then
		mbLabel.text = Value
	End If
End Sub

Public Sub setValue2(Value As Int)
	mbBtn2.Left = Round ((Value - minValue) * ((mbBackground.Width-mbBtn2.Width) / (maxValue- minValue)))
	Redraw_Background(True)
	If textVisible = True Then
		mbLabel2.text = Value
	End If
End Sub

Public Sub Enable
	mbBtn.SetBackgroundImage(cvs_normal.Bitmap)
	Redraw_Background(True)
	mbBackground.Enabled = True
	If textVisible = True Then
		mbLabel.Visible = True
	End If	
End Sub

Public Sub Disable
	mbBtn.SetBackgroundImage(cvs_disabled.Bitmap)
	Redraw_Background(False)
	mbBackground.Enabled = False
	If textVisible = True Then
		mbLabel.Visible = False
	End If
End Sub
